#################################################
#Patchfile for Pirate Mod			#
#################################################

%ext ck3


#################################################
#FILES						#
#################################################

#Don't show B800 screen - free up space for sounds and texts
%patch $11F5 $EB

#New tile properties
%patchfile $198C8 TILES.tli

#Helptext location = $159FE
%patch $86AD $159FRW
%patch $86B0 $000EW

#Previewtext location = $159FE
%patch $86E9 $159FRW
%patch $86EC $000EW

#Storytext location = $14CDC
%patch $86C1 $14CDRW
%patch $86C4 $000CW

#Endtext location = $16D6E
%patch $86D5 $16D6RW
%patch $86D8 $000EW


#################################################
#Misc assorted patches				#
#################################################

#Don't turn off god mode on level entry
%patch $81D1 $90 $90 $90

#Remove EKA
%patch $0F9B $EB $37

#Score h position
%patch $0F86 $0C

#2nd line is blank
%patch $1BB12 $0A $00

#Alter actual status box
%patch $1BAF4 "           SCORE:           " $0A $00
%patch $1BB3C " LORDS GONE       KEYS      " $0A $00
%patch $1045 $00D7W #Ankh tile

#Ankh now tracks pogo
%patch $1073 $FF $36 $9D1AW  $EB $04

#Rearrange highscores to fit new graphics
%patch $A155 $0011W #High scores h moves across 2x8
%patch $A163 $002EW #Name v moves 2 down
%patch $A175 $002EW #Score v moves 2 down
%patch $A179 $001AW #Score h moves back 2x8

#Single bullet now single life
%patch $7BD2 $FF $06 $9D46W	#Give life
%patch $7BFA $1C		#Change sound

#Get gun sound is +1
%patch $7ADD $0B


#################################################
#Ending sequence surprise			#
#################################################

#1 flash instead of 5
%patch $5B8A $E9 $0105W

#Flash doesn't change tiles
%patch $5C92 $A1 $34 $6E $BA $0008W  $F7 $EA $05 $0008W  $D1 $E0 $C4 $1E $74
             $6E $03 $D8 $26 $C7 $07 $008FW  $E8 $E0 $A5 $E8 $58 $FD $90
             $EB $1A $6E $BA $0008W  $F7 $EA $05 $0008W  $D1 $E0 $C4 $1E $74
             $6E $03 $D8 $26 $C7 $07 $008FW  $E8 $C1 $A5 $90
             $B8 $000FW  $50 $E8 $84 $6E $59

#Flashes DARKEN palette two shades
%patch $5A15 $2575W #Flash as Vorterazi take pictures
%patch $5A44 $2586W #Return to normal palette after

#Don't change level to ending level until...
%patch $5AA2 $90 $90 $90 #After first textbox
%patch $5AE9 $90 $90 $90 #After second
%patch $5B25 $90 $90 $90 #Third
%patch $5B61 $90 $90 $90 #Fourth textbox is done

#Don't show... (Just to be sure)
%patch $5A73 $EB $16 #Don't show Vorticon
%patch $5A8B $EB $15 #Don't show Keen

#Reveal sound
%patch $5A2D $28

#Text 1
%patch $1C414 "Sub Lt Woofer?" $00

#Finale window 1
%patch $5AA8 $B8 $0017W  $50 $B8 $001FW  $50 $B8 $0015W  $50 $B8 $0010W  $50
             $E8 $C9DAW  $83 $C4 $08 $B8 $2BF4W  $50 $E8 $3968W  $59 $B8 $0050W  
                 $50 $E8 $708BW  $59 $E8 $66DBW  

#Text 2
%patch $1C423 "R! That be Cap'n Bluebark to ye lad!" $00

#Finale window 2
%patch $5AD1 $B8 $0017W  $50 $B8 $002AW  $50 $B8 $0015W  $50 $B8 $0005W  $50
             $E8 $C9B1W  $83 $C4 $08 $B8 $2C03W  $50 $E8 $393FW  $59 $B8 $0050W  
                 $50 $E8 $7062W  $59 $E8 $66B2W  

#Text 3
%patch $1C448 "But he's dead... isn't he? Wasn't he" $0A
             "hung from-" $00

#Finale window 3
%patch $5AFA $B8 $0017W  $50 $B8 $002BW  $50 $B8 $0014W  $50 $B8 $0004W  $50
             $E8 $C988W  $83 $C4 $08 $B8 $2C28W  $50 $E8 $3916W  $59 $B8 $0004W  
                 $50 $E8 $7039W  $59 $E8 $6689W  

#Text 4
%patch $1C478 "The fore-mast, aye. But thanks to ye" $0A
             "I'm back! And now t' take me ship an'" $0A
             "finnish off those rats ye left alive!" $00

#Finale window 4
%patch $5B23 $B8 $0017W  $50 $B8 $002BW  $50 $B8 $0013W  $50 $B8 $0004W  $50
             $E8 $C95FW  $83 $C4 $08 $B8 $2C58W  $50 $E8 $38EDW  $59 $B8 $0078W  
                 $50 $E8 $7010W  $59 $E8 $6660W  

#Text 5
%patch $1C4E9 "So you surviv-" $00

#Finale window 5
%patch $5B4C $B8 $0017W  $50 $B8 $001FW  $50 $B8 $0015W  $50 $B8 $0010W  $50
             $E8 $C936W  $83 $C4 $08 $B8 $2CC9W  $50 $E8 $38C4W  $59 $B8 $0004W  
                 $50 $E8 $6FE7W  $59 $E8 $6637W  $E9 $0012W

#How long to wait after flashes before finale screen
%patch $5CD6 $0128W

#Don't play sounds
%patch $5D7C $EB $06 #Congratulations sound

#New sound for endtext
%patch $5D88 $22


#################################################
#Level names					#
#################################################

#Keen sees a galaxy style window appearbefore each level loads
#SIDE EFFECT: No Messie

#Move up Teleporter-BwB-level entry call code
%patch $B74A $83 $3E $70ECW  $00 $74 $1B $FF $76 $F2 $FF $76 $F4 $56 $FF $36
             $70ECW  $E8 $0063W  $83 $C4 $08 $0B $C0 $74 $06 $C7 $06 $70ECW 
             $0000W  $5F $5E $8B $E5 $5D $C3

#Move code pointer list
%patch $B772 $B4EAW $B4F6W $B507W $B513W $B524W $B530W $B541W $B4D9W

#New list location
%patch $B4D7 $B772W

#Level name code pointer list
%patch $B782 $B802W  $B808W  $B80EW  $B814W  $B81AW  $B820W  $B826W $B82CW
             $B832W  $B838W  $B83EW  $B844W  $B84AW  $B850W  $B856W $B85CW
             $B862W  $B868W  $B86EW  $B874W  $B87AW  $B880W  $B886W $B88CW
             $B892W  $B898W  $B89EW  $B8A4W  $B8AAW  $B8B0W  $B8B6W $B8BCW  

#New expanded level entry code, includes level entrance texts
%patch $B7C2 $55 $8B $EC $83 $EC $04 $56 $57 $83 $7E $04 $21 $72 $03 $E9 $0176W
                 $A1 $70ECW  $8B $F8 $B8 $0005W  $50 $B8 $000FW  $50 $E8 $6E55W
                 $59 $59 $B8 $35E4W  $50 $E8 $7057W  $59 $8B $36 $86 $82 $8B
                 $DF $83 $FB $20 $76 $03 $E9 $00C1W  $D1 $E3 $2E $FF $A7 $B780W

#Level name code
%patch $B802 $B8 $3186W  $50 $EB $04 $B8 $319FW  $50 $EB $7C $B8 $31B7W  $50 $EB $76 #1-3
             $B8 $31D0W  $50 $EB $70 $B8 $31EDW  $50 $EB $6A $B8 $2E75W  $50 $EB $64 #4-6
             $B8 $2E91W  $50 $EB $5E $B8 $2EACW  $50 $EB $58 $B8 $2ECAW  $50 $EB $52 #7-9
             $B8 $2EE5W  $50 $EB $4C $B8 $271DW  $50 $EB $46 $B8 $2739W  $50 $EB $40 #10-12
             $B8 $2700W  $50 $EB $3A $B8 $2690W  $50 $EB $34 $B8 $2752W  $50 $EB $2E #13-15
             $B8 $26ADW  $50 $EB $28 $B8 $2F1CW  $50 $EB $22 $B8 $2F01W  $50 $EB $1C #16-18
             $B8 $2F33W  $50 $EB $16 $B8 $25A8W  $50 $EB $10 $B8 $25C7W  $50 $EB $0A #19-21
             $B8 $25E5W  $50 $EB $04 $B8 $2602W  $50 $EB $7A $B8 $261DW  $50 $EB $74 #22-24
             $B8 $2638W  $50 $EB $6E $B8 $2658W  $50 $EB $68 $B8 $2674W  $50 $EB $62 #25-27
             $B8 $26C7W  $50 $EB $5C $B8 $26E4W  $50 $EB $56 $B8 $276FW  $50 $EB $50 #28-30
             $B8 $278CW  $50 $EB $4A $B8 $27A7W  $50 $EB $44			     #31,32+

#Level names and entry text
%patch $1CE04 "Commander Keen" $0A $00
%patch $1C9A6 "   explores" $0A
              "  Golden Bay" $00	#Level 1
%patch $1C9BF "   crosses" $0A
              " Silver Pass" $00	#Level 2
%patch $1C9D7 "    braves" $0A
              " The Badlands" $00	#Level 3
%patch $1C9F0 "chugs through" $0A
              "Whiskey Tavern" $00	#Level 4
%patch $1CA0D "makes waves in" $0A
              " Palm Springs" $00	#Level 5
%patch $1C695 "slogs through" $0A
              "Loading Docks" $00	#Level 6
%patch $1C6B1 " is fired up" $0A
              "by L.L Sailor" $00	#Level 7
%patch $1C6CC "boldly enters" $0A
              "Spleen's Castle" $00	#Level 8
%patch $1C6EA "puzzles over" $0A
              " Castle Lass" $00	#Level 9
%patch $1C705 "spelunks into" $0A
              " Hawk Caverns" $00	#Level 10
%patch $1BF3D " plunders the" $0A
              " X.R. Laurael" $00	#Level 11
%patch $1BF59 " loots the" $0A
              "K.R. Cakewalk" $00	#Level 12
%patch $1BF20 "battles through" $0A
              " Castle Rush" $00	#Level 13
%patch $1BEB0 " enjoys a New" $0A
              " Zealand Story" $00	#Level 14
%patch $1BF72 "dives into the" $0A
              "  Wreck Wreef" $00	#Level 15
%patch $1BECD "  boards the" $0A
              "C.L. Sealick" $00	#Level 16
%patch $1C73C "   ascends" $0A
              "  Mt Tedius" $00		#Level 17
%patch $1C721 "boats across" $0A
              "Silver Stream" $00	#Level 18
%patch $1C753 "  flits over" $0A
              " Feather Pass" $00	#Level 19
%patch $1BDC8 "needs a SharKey" $0A
              "for Door Gorge" $00	#Level 20
%patch $1BDE7 "  soars over" $0A
              "Withring Height" $00	#Level 21
%patch $1BE05 "creeps through" $0A
              " Dank Caverns" $00	#Level 22
%patch $1BE22 "totally bombs" $0A
              "  The Bridge" $00	#Level 23
%patch $1BE3D "   ransacks" $0A
              "Treasure Trove" $00	#Level 24
%patch $1BE58 "dips his toe in" $0A
              "Watercross Ruin" $00	#Level 25
%patch $1BE78 "detonates the" $0A
              "C.S. Exotherm" $00	#Level 26
%patch $1BE94 "shoots by the" $0A
              " C.S. Quannon" $00	#Level 27
%patch $1BEE7 "tries to Reach" $0A
              " For The Xky!" $00	#Level 28
%patch $1BF04 "wanders around" $0A
              "  SharCastle" $00	#Level 29
%patch $1BF8F "happens upon" $0A
              "Ridley's Castle" $00	#Level 30
%patch $1BFAC " invades the" $0A
              "C.L. Imperial" $00	#Level 31
%patch $1BFC7 "'audits' the" $0A
              "X.R. Vortiflora" $00	#Level 32

#Press a key text
%patch $B90F $0002W #Number of lines text starts at

#Press a key message (note it starts with $0A)
%patch $1CFC8 $0A " press any key" $00

#Play a sound when message window appears AND enters level after window (with sound!)
%patch $B91C $B8 $001AW  $50 $E8 $1046W  $59 $E8 $6893W  $E8 $02D6W  $E8 $688DW
                 $E8 $087CW  $B8 $001FW  $50 $E8 $1032W  $59 $EB $0F

#Change press any key animation to be more useful
%patch $BC12 $10

#Saved files read from:
%patch $A2BD $3215W #Save to (Save text space)


#################################################
#Ceilick boss conversation			#
#################################################


#Text 1
%patch $1C165 "Captain Keen, we meet at last!" $00

#Mortimer window 1
%patch $5721 $B8 $0001W  $50 $B8 $001EW  $50 $E8 $FEA8W  $59 $59 $E8 $6A7BW 
             $B8 $2945W  $50 $E8 $FF6AW  $59 $0B $C0 $74 $06 $E8 $AB4DW  $E9
             $02C3W  $B8 $00B4W  $50 $E8 $FF0AW  $59 $0B $C0 $74 $06 $E8 $AB3BW  
                 $E9 $02B1W  $E8 $AB35W  $E8 $6A51W  

#Text 2
%patch $1C184 "Lord 'Lick." $00

#Mortimer window 2
%patch $575B $B8 $0001W  $50 $B8 $000BW  $50 $E8 $FE6EW  $59 $59
             $B8 $2964W  $50 $E8 $FF33W  $59 $0B $C0 $74 $06 $E8 $AB16W  $E9
             $028CW  $B8 $00B4W  $50 $E8 $FED3W  $59 $0B $C0 $74 $06 $E8 $AB04W  
                 $E9 $027AW  $E8 $AAFEW  $E8 $6A1AW  

#Text 3
%patch $1C190 "You've done well disposing of the" $0A
             "others; take their place and together" $0A
             "we can loot the universe!" $00

#Mortimer window 3
%patch $5792 $B8 $0003W  $50 $B8 $0026W  $50 $E8 $FE37W  $59 $59
             $B8 $2970W  $50 $E8 $FEFCW  $59 $0B $C0 $74 $06 $E8 $AADFW  $E9
             $0255W  $B8 $00FAW  $50 $E8 $FE9CW  $59 $0B $C0 $74 $06 $E8 $AACDW  
                 $E9 $0243W  $E8 $AAC7W  $E8 $69E3W  

#Text 4
%patch $1C1F2 "I don't think so." $00

#Mortimer window 4
%patch $57C9 $B8 $0001W  $50 $B8 $0011W  $50 $E8 $FE00W  $59 $59
             $B8 $29D2W  $50 $E8 $FEC5W  $59 $0B $C0 $74 $06 $E8 $AAA8W  $E9
             $021EW  $B8 $00B4W  $50 $E8 $FE65W  $59 $0B $C0 $74 $06 $E8 $AA96W  
                 $E9 $020CW  $E8 $AA90W  $E8 $69ACW  

#Text 5
%patch $1C204 "But at heart you are a pirate! Do you" $0A
             "not steal goodies wherever you go?" $0A
             "Are you not King of Candy?" $00

#Mortimer window 5
%patch $5800 $B8 $0003W  $50 $B8 $0026W  $50 $E8 $FDC9W  $59 $59
             $B8 $29E4W  $50 $E8 $FE8EW  $59 $0B $C0 $74 $06 $E8 $AA71W  $E9
             $01E7W  $B8 $00FAW  $50 $E8 $FE2EW  $59 $0B $C0 $74 $06 $E8 $AA5FW  
                 $E9 $01D5W  $E8 $AA59W  $E8 $6975W  

#Text 6
%patch $1C268 "That's different, I... shut up!" $00

#Mortimer window 6
%patch $5837 $B8 $0001W  $50 $B8 $001FW  $50 $E8 $FD92W  $59 $59
             $B8 $2A48W  $50 $E8 $FE57W  $59 $0B $C0 $74 $06 $E8 $AA3AW  $E9
             $01B0W  $B8 $00B4W  $50 $E8 $FDF7W  $59 $0B $C0 $74 $06 $E8 $AA28W  
                 $E9 $019EW  $E8 $AA22W  $E8 $693EW  

#Text 7
%patch $1C288 "Blackbeard, Long John Silver, Johnny" $0A
             "Depp and YOU: Billy the Kid!" $0A
             "" $0A
             "Think of the possibilities!" $00

#Mortimer window 7
%patch $586E $B8 $0004W  $50 $B8 $0026W  $50 $E8 $FD5BW  $59 $59
             $B8 $2A68W  $50 $E8 $FE20W  $59 $0B $C0 $74 $06 $E8 $AA03W  $E9
             $0179W  $B8 $00FAW  $50 $E8 $FDC0W  $59 $0B $C0 $74 $06 $E8 $A9F1W  
                 $E9 $0167W  $E8 $A9EBW  $E8 $6907W  

#Text 8
%patch $1C2E7 "No, all my candy goes to the Molly" $0A
             "McMire Fund for Blind Yorps. I will" $0A
             "never join you!" $00

#Mortimer window 8
%patch $58A5 $B8 $0003W  $50 $B8 $0024W  $50 $E8 $FD24W  $59 $59
             $B8 $2AC7W  $50 $E8 $FDE9W  $59 $0B $C0 $74 $06 $E8 $A9CCW  $E9
             $0142W  $B8 $00C8W  $50 $E8 $FD89W  $59 $0B $C0 $74 $06 $E8 $A9BAW  
                 $E9 $0130W  $E8 $A9B4W  $E8 $68D0W  

#Text 9
%patch $1C33E "I see. Then I guess I have no choice" $0A
             "but to have my crew make you more holy" $0A
             "than the pope." $00

#Mortimer window 9
%patch $58DC $B8 $0003W  $50 $B8 $0026W  $50 $E8 $FCEDW  $59 $59
             $B8 $2B1EW  $50 $E8 $FDB2W  $59 $0B $C0 $74 $06 $E8 $A995W  $E9
             $010BW  $B8 $00C8W  $50 $E8 $FD52W  $59 $0B $C0 $74 $06 $E8 $A983W  
                 $E9 $00F9W  $E8 $A97DW  $E8 $6899W  

#Text 10
%patch $1C399 "What...?" $00

#Mortimer window 10
%patch $5913 $B8 $0001W  $50 $B8 $0008W  $50 $E8 $FCB6W  $59 $59
             $B8 $2B79W  $50 $E8 $FD7BW  $59 $0B $C0 $74 $06 $E8 $A95EW  $E9
             $00D4W  $B8 $005AW  $50 $E8 $FD1BW  $59 $0B $C0 $74 $06 $E8 $A94CW  
                 $E9 $00C2W  $E8 $A946W  $E8 $6862W  

#Text 11
%patch $1C3A2 "Holy. As in full of holes. Bullet" $0A
             "holes." $00

#Mortimer window 11
%patch $594A $B8 $0002W  $50 $B8 $0022W  $50 $E8 $FC7FW  $59 $59
             $B8 $2B82W  $50 $E8 $FD44W  $59 $0B $C0 $74 $06 $E8 $A927W  $E9
             $009DW  $B8 $00BEW  $50 $E8 $FCE4W  $59 $0B $C0 $74 $06 $E8 $A915W  
                 $E9 $008BW  $E8 $A90FW  $E8 $682BW  

#Text 12
%patch $1C3CB "Well good luck, because I'm not" $0A
             "catholic!" $00

#Mortimer window 12
%patch $5981 $B8 $0002W  $50 $B8 $0020W  $50 $E8 $FC48W  $59 $59
             $B8 $2BABW  $50 $E8 $FD0DW  $59 $0B $C0 $74 $06 $E8 $A8F0W  $E9
             $0066W  $B8 $00B4W  $50 $E8 $FCADW  $59 $0B $C0 $74 $06 $E8 $A8DEW  
                 $E9 $0054W  $E8 $A8D8W  $E8 $67F4W  

#Text 13
%patch $1C3F5 "Wha- Someone kill him already!" $00

#Mortimer window 13
%patch $59B8 $B8 $0001W  $50 $B8 $001EW  $50 $E8 $FC11W  $59 $59
             $B8 $2BD5W  $50 $E8 $FCD6W  $59 $0B $C0 $74 $06 $E8 $A8B9W  $E9
             $002FW  $B8 $0078W  $50 $E8 $FC76W  $59 $0B $C0 $74 $06 $E8 $A8A7W  
                 $E9 $001DW  $E8 $A8A1W  $E8 $67BDW  $E9 $0014W 


#################################################
#Sounds						#
#################################################

#Sound file location now at B800 screen location
%patch $14D3 $12ACRW

#Patch the sound files:
%patchfile $12AC0 SOUNDS.CK3	#New sound data

#Keen fall sound disabled
%patch $714B $EB $06

#Use new sound for Pogo
%patch $7735 $0D

#Disable death when falling out of level sound
%patch $7989 $EB $06

#Keen enter level sound disabled (Don't ask why)
%patch $8DA3 $EB $06

#Walk on map sound disabled
%patch $B5CB $EB $06


#################################################
#About Id and Keen info				#
#################################################

#Bitmap
%patch $A0E8 $0010 #V position, in pixels
%patch $A0EC $0015 #H position, in 8x8 blocks

#Text setup:
%patch $A0F6 $0005W #Text H position
%patch $A102 $0007W #Text V position (in lines)
%patch $A10B $0128W #Length of text lines (long)
%patch $A11D $01    #Number of lines

#Text
%patch $1C870 "You're currently playing a mod of" $0A
              "Commander Keen: 'Invasion of the" $0A
              "Vorticons!'" $0A $0A
              "Commander Keen can be ordered online" $0A
              "on Steam at the following address:" $0A $0A $0A
              "http://store.steampowered.com/app/9180/" $0A $0A
%patch $1C933 "This is episodes 1-5 but not 6 or 7" $0A
              "which can be downloaded as shareware." $0A
              "A helpful site is:" $0A $0A
              "http://www.pckf.com/" $00


#################################################
#Gameplay					#
#################################################

#Change gravity to compensate for game smoothness
%patch $62C6 $00F8W   #Max fall speed 1
%patch $62CE $00F8W   #Max fall speed 2


#Change game framerate
%patch $26D $04


#Change the Done tile markers
%patch $8B31 $0079W #Small marker
%patch $8BAA $0001W #Big marker top left
%patch $8BC3 $0002W #Big marker top right
%patch $8BDA $000EW #Big marker bottom left
%patch $8BF4 $000FW #Big marker bottom right


#Don't display text
%patch $1242 $EB $06 #Loading
%patch $1263 $EB $06 #Joy detected
%patch $1273 $EB $06 #Joy not detected
%patch $12A5 $EB $06 #Keystrokes
%patch $12BA $EB $06 #EGA
%patch $12CB $EB $06 #VGA

#Adjust Keens left sprite
%patch $983E $007CW
%patch $984B $0008W #Sprite position
%patch $9813 $0005W #Height
%patch $9826 $301FW
%patch $1C83F "Commander Keen" $0A
              "boldly explores" $0A
              "  Vorticon V" $00

#Don't display lives in Keens Left window (Frees $983F-$985E)
%patch $983D $EB $20

#Change the controls to: Space, shoot; Enter, status.
%patch $11AF  $5274W
%patch $8D6E  $5274W
%patch $71C9  $90 $90 $90 $90 $90 $90 $90 $80 $3E $5291W  $00
%patch $72FA  $90 $90 $90 $90 $90 $90 $90 $80 $3E $5291W  $00
%patch $7461  $90 $90 $90 $90 $90 $90 $90 $80 $3E $5291W  $00
%patch $7474  $90 $90 
%patch $7515  $90 $90 $90 $90 $90 $90 $90 $80 $3E $5291W  $00
%patch $76A1  $90 $90 $90 $90 $90 $90 $90 $80 $3E $5291W  $00
%patch $7750  $90 $90 $90 $90 $90 $90 $90 $80 $3E $5291W  $00

#Dead Keen same height as normal Keen;
#Reset score on death A
%patch $7928 $66 $81 $06 $0E $71 $00 $00 $00 $00 $66 $A1 $AF00W  $66 $A3 $9D4AW  $90 $90

#Reset score on death B
%patch $7965 $66 $81 $06 $0E $71 $00 $00 $00 $00 $66 $A1 $AF00W  $66 $A3 $9D4AW  $90 $90

#Save score on level load
%patch $81B7 $66 $A1 $9D4AW  $66 $A3 $AF00W  $66 $33 $C0 $66 $A3 $5361W  $66
             $A3 $586AW  $A3 $5D40W  $90


#New palette
#This is the color palette: 16 entries of r, g, b (each 063)
%patch $19824
       00 00 00 #black 
       09 14 58 #blue 
       41 51 13 #green 
       42 03 03 #Dark dark grey
       45 30 05 #brown
       58 36 15 #orange
       21 18 15 #stone grey
       41 41 41 #bright gray 
       09 12 15 #gray 
       15 41 60 #bright blue 
       21 36 09 #dark green 
       44 54 58 #blue-white
       46 12 17 #dark pink
       54 30 37 #pink 
       60 56 29 #yellow 
       63 63 63 #white 

# Set the palette stuff
%patch $2FE0  $E8 $58 $E5 $90 $90
%patch $153A              $C3 $B8 $0D $00 $CD
              $10 $B8 $12 $10 $B9 $08 $00 $BB
              $00 $00 $8C $DA $8E $C2 $BA $04
              $00 $CD $10 $BB $18 $00 $BA $1C
              $00 $CD $10 $C3

#Palettes
%patch $1BD84  $00 $00 $00 $00 $00 $00 $00 $00  $00 $00 $00 $00 $00 $00 $00  $00 $19 #Black
%patch $1BD95  $00 $00 $18 $00 $18 $06 $00 $18  $00 $18 $00 $01 $00 $03 $06  $06 $19 #Fade 2
%patch $1BDA6  $00 $00 $1A $00 $06 $04 $18 $06  $00 $01 $18 $19 $03 $1C $05  $07 $19 #Fade 1
%patch $1BDB7  $00 $01 $02 $03 $04 $05 $06 $07  $18 $19 $1A $1B $1C $1D $1E  $1F $19 #'Normal


#32 levels:
#Let Keen enter levels if these values are 0
%patch $8AE2  $90 $90 $80 $BF $26 $9D $00
%patch $8D9A  $90 $90 $80 $BF $25 $9D $00

#When starting a new game, make all 32 levels not done
%patch $9944  $90 $90 $C6 $87 $26 $9D $00 $90
%patch $994F  $20

#Change things when marking a level as done
%patch $8DE1  $90 $90 $C6 $87 $25 $9D $01 $90
%patch $8BF9  $20


#Can't clip through map with godmode
%patch $AF77 $EB 

#Pogo doesn't fly with godmode 
%patch $75F3 $EB 

#Keen can still be stunned by Youths with GOD mode - Keen 3
%patch $7C83 $90 $90

#Youths stun Keen even with Ankh
%patch $7C8A $EB

#Don't draw exit tiles
%patch $77E6 $90 $90 $90 #Top left tile
%patch $7810 $90 $90 $90 #Bottom left tile
%patch $783A $90 $90 $90 #Top right tile
%patch $786A $90 $90 $90 #Bottom right tile


#Change point item scores
%patch $1C083 $0014W #20
              $0005W #5
              $000AW #10
              $0032W #50
              $0064W #100

#Disable EKA (Free $0DE9-$0E21)
%patch $0DE7 $5D $C3


#################################################
#Start sequence stuff				#
#################################################

#Rearrange start stuff to use less graphics
%patch $3135 $0008W #Image used (One moment)

#APOGEE
%patch $A9C6 $0007W #Image used

#Only display one bitmap
%patch $A9DC $B8 $0007W  $50 $B8 $0032W  $50 $B8 $0010W  $50 $E8 $1B41W  $83
             $C4 $06 $5D $C3


#################################################
#Main menu					#
#################################################

#Stop demo sequence
%patch $9A3C $00FAW

#Don't show F1 bitmap
%patch $A099 $5D $C3

#Versatile Main Menu patch:
#Main Menu size
%patch $9EF0 $09 #Height
%patch $9EF4 $12 #Width

#Number of menu items
%patch $9CF6 $06 
%patch $9C72 $06 
%patch $9EB9 $06 

#Menu pointers (What items DO)
%patch $9EDC $9E4FW #New game	 '   New Game'
             $9E56W #Load game	 '   Continue Game'
             $9E5EW #Story	 '   Story'
             $9E78W #Scores	 '   The Keenest'
             $9E9CW #Previews	 '   Help'
             $9E68W #About Id	 '   Info'
             $9EACW #Demo	 '   Restart Demo'

#Simple Main Menu text patch
%patch $9F13 $2FB5W  $50 $E8 $892AW  $59 $EB $3E

#Menu text
%patch $1C7D5 "   New Game" $0A
              "   Continue Game" $0A
              "   Story" $0A
              "   The Keenest" $0A
              "   Help" $0A
              "   Game info" $0A
              "   Close window" $0A $0A
              "Use the arrows" $00

#No 'arrows' etc texts
%patch $9F5A $EB $2A

#Menu cursor doesn't animate
%patch $9BFA $00 #Animation frames - 1
%patch $9C61 $00 #Animation frames - 1
%patch $9D42 $00 #Animation frames - 1

#F3 savegame, no definition windows
%patch $0CE9 $0004W #Remove F4\5
%patch $0DBF $0D6CW #F3: Save game

#Move title screen
%patch $A08C $000AW #Title V
%patch $A090 $0007W #Title H

#When quit, no GAME OVER bitmap or sound
%patch $952B $8B $C7 $4F $0B $C0 $75 $03 $E9 $FAD5W
             $B8 $0002W  $50 $A1 $86 $82 $D1 $E0 $D1 $E0 $D1 $E0 $50 $A1 $16 #Winner bmp
             $82 $05 $0009W  $50 $E8 $2FDFW  $83 $C4 $06 $B8 $001DW  $50 $E8 #Highsound
             $3412W  $59 
%patch $900A $B8 $0006W  $50 $A1 $86 $82 $D1 $E0 $D1 $E0 $D1 $E0 $50 $A1 $16 #Game over bmp
             $82 $05 $0009W  $50 $E8 $350AW  $83 $C4 $06 $B8 $0010W  $50 $E8 #Game over sound
             $393DW  $59 $E9 $06CEW


#################################################
#Keen						#
#################################################

#Rearrange Keen's animations to use new graphics:
#Walking is two frames
%patch $709A $0001W #And next 3 frames
%patch $70C1 $0001W #And next 3 frames

%patch $73D3 $000DW #Jumping/falling right
%patch $7D3B $0013W #Jumping/falling left

#Exiting Keen animation (0)
%patch $77C2 $01   #Frames used by Keen exiting -1

#Ankh shield has one frame
%patch $850A $0000W #Frames used
%patch $854F $001EW #Sprite used (Flashing)
%patch $854C $0000W #Frames used

#Solid shield -1,+1
%patch $851A $FF    #Vertical position
%patch $851C $FFFFW
%patch $852A $01    #Horizontal position
%patch $852C $0000W

#Flashing shield -1,+1
%patch $855C $FE    #Vertical position
%patch $855E $FFFFW
%patch $856C $00    #Horizontal position
%patch $856E $0000W

#Solid bubble with God mode (None without)
%patch $84F2 $5FD6W $00 $75 $0A $E9 $0092W

#Flashing shield doesn't flash
%patch $8542 $90 $90

#Ankh flashing time (Always use flashy shield)
%patch $84FC $9946W $00FAW $EB


#Keen 3 Keen's shooting rate (fastest!)
%patch $7512 $00


#On ice Keen is fired into the air
%patch $7046 $83 $3E $D6 $5F $00 $75 $15 $C7 $06 $42 $99 $7230W  $B8 $0017W 
                 $50 $E8 $590FW  $59 $C7 $06 $32 $99 $FE00W  $90

#Map Keen uses only two boat animations
%patch $B4E6 $1F $00 #Keen on map moving up left
%patch $B4F2 $1F $00 #Keen on map moving up
%patch $B503 $1F $00 #Keen on map moving up right
%patch $B50F $1F $00 #Keen on map moving right
%patch $B520 $1F $00 #Keen on map moving down left
%patch $B52C $1F $00 #Keen on map moving down
%patch $B53D $1F $00 #Keen on map moving down right
%patch $B549 $1F $00 #Keen on map moving left
%patch $B562 $01 $00 #Frames used by all map sprites
%patch $8AA9 $1F $00 #Initial map sprite


#Change Keen's firing angle by using ^v keys in-game.
%patch $1B4A $90 $90 $2E $A1 $7D0CW  $8B $1E $BA $96 $D1 $E3 $2E $FF $A7 $804BW
                 $2E $A1 $805FW  $2E $A3 $7D0CW  $EB $08 $2E $A1 $805DW  $2E
             $A3 $7D0CW  $2E $A1 $8061W  $2E $A3 $7D22W  $2E $A3 $7D95W  $EB
             $1B $2E $A1 $8061W  $2E $A3 $7D0CW  $2E $A1 $805DW  $2E $A3 $7D22W
             $2E $A1 $805FW  $2E $A3 $7D95W  $90 $90 $90

#Jump table (Make Keen's shot move much faster)
%patch $8048 $C3 $1B5BW  $1B5BW  $1B5BW  $1B7BW  $1B65W  $1B65W
                 $1B65W  $1B7BW  $1B5BW  $1B7BW  $04B0W  $FB50W
                 $0000W

#Keen dies instead of recovering from stunning -reset score C
%patch $5576 $1D $C7 $06 $44 $99 $6A00W  $C7 $06 $42 $99 $789EW  $66 $81 $06
             $0E $71 $0000w  $0000W  $66 $A1 $AF00W  $66 $A3 $9D4AW  $C7 $06
             $9930W  $0000W  $E8 $0D17W  $E8 $0D57W  $E8 $1462W  $5D $C3  


#Play a sound when Keen is stunned, reduce stun time
%patch $7C8E $C7 $44 $32 $5553W  $C7 $44 $2A $0080W  $B8 $0001W $50 $E8 $4CCAW
             $59 $EB $12


#Fix bizare no shooting bug (Skip right wall&Keen check)
%patch $7D62 $EB


#################################################
#Vorticon Pirate				#
#################################################

#Vorticon spawn (One direction.)
%patch $3C20 $55 $8B $EC $56 $E8 $2396W  $8B $F0 $C7 $04 $0002W  $8B $46 $04 #Sprite type = 2
             $99 $B1 $0C $E8 $AF8BW  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $AF7CW  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $414AW  #Behavior = $414A
             $C7 $44 $34 $42D0W  $C7 $44 $24 $0001W  $C7 $44 $20 $FFA6W  $C7 #Collision = $42D0, h=1
             $44 $28 $0041W  $5E $5D $C3				     #Speed +-5A sprite = 47

#Vorticon look for Keen code less animation
%patch $4275 $55 $8B $EC $83 $3E $3A $99 $00 $7C $29 $C7 $06 $30 $99 $005AW
             $A1 $16 $99 $8B $16 $14 $99 $3B $06 $0C $71 $7C $10 $7F $06 $3B
             $16 $0A $71 $76 $08 $A1 $30 $99 $F7 $D8 $A3 $30 $99 $C7 $06 $42
             $99 $414AW  $E8 $2009W  $E8 $2049W  $5D $C3

#Jumping (-2)
%patch $4236 $0047W #Jumping right
%patch $423E $0048W #Jumping left

#When shot (-2)
%patch $4301 $0049W #When shot

#Vorticon pirate sensitive to Sharkey's shot, not Vizard's )Vizard's kills all.)
%patch $42E2 $11


#################################################
#Vortikid-> Jumpfish				#
#################################################

#Goes to Vortikid (Code at $3AE9 + $194 + 5 = $3C82)
%patch $3AE9 $56 $57 $E8 $0179W  $59 $59 $E9 $00C7W	

#Vortikid spawn - Vortikid has no speed when it starts
%patch $3C67 $55 $8B $EC $56 $E8 $234FW  $8B $F0 $C7 $04 $0003W  $8B $46 $04 #Sprite type = 3
             $99 $B1 $0C $E8 $AF44W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $AF35W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $4311W  #Behavior = $4311
             $C7 $44 $34 $4377W  $C7 $44 $24 $0001W  $C7 $44 $28 $002FW  $5E #Collision = $43D9, health = 1, sprite = 2F
             $5D $C3

#Vortikid just jumps up and down (Free $43AA-$4408)
#Vortikid run\jump code - simply jump up and down
%patch $4311 $55 $8B $EC $56 $C7 $06 $38 $99 $002FW  $A1 $61 $53 $B1 $04 $D3 $E8
             $25 $0001W  $8B $16 $38 $99 $03 $D0 $89 $16 $38 $99 $E8 $8812W 
             $50 $A1 $40 $5D $BA $03 $00 $F7 $EA $5A $3B $D0 $73 $13 $B8 $0190W
                 $50 $E8 $878BW  $59 $F7 $D8 $A3 $32 $99 $C7 $06 $42 $99 $435CW
                 $E8 $1F5EW  $E8 $1F9EW  $5E $5D $C3

#Vortikid fall code
%patch $435C $55 $8B $EC $56 $E8 $1F51W  $E8 $1F91W  $8B $F0 $F7 $C6 $02 $00
             $74 $06 $C7 $06 $42 $99 $4311W  $5E $5D $C3

#New collision code (Basically relocated.)
%patch $4377 $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $0F $75 $21 $B8
             $0013W  $50 $E8 $85DCW  $59 $C7 $44 $2A $0000W  $C7 $44 $2C $0002W
                 $C7 $44 $28 $0031W  $C7 $44 $34 $6A00W  $C7 $44 $32 $7EC0W
             $5E $5D $C3


#################################################
#Vizard	- Little changed from Vortimom		#
#################################################

#Goes to Vortimom (Code at $3AF3 + $25F + 5 = $3D57)
%patch $3AF3 $56 $57 $E8 $025FW  $59 $59 $E9 $00BDW	

#Vortimom spawn
%patch $3D57 $55 $8B $EC $56 $E8 $225FW  $8B $F0 $C7 $04 $0004W  $8B $46 $04 #Sprite type = 4
             $99 $B1 $0C $E8 $AE54W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $AE45W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $440CW  #Behavior = $440C
             $C7 $44 $34 $470CW  $C7 $44 $24 $0005W  $C7 $44 $20 $FFCEW  $C7 #Collision = $470C, health = 5
             $44 $28 $0055W  $5E $5D $C3				     #Speed -50, sprite = 55

#Shots follow Keen - Shootable
%patch $456D $4E89W #Behavior: Chase Keen (See code far below)
%patch $4578 $5056W #Collision, fall down

#Vizard shot collision (Explode when hitting non Vizard)
%patch $5056 $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $04 $74 $20 $B8
             $0021W  $50 $E8 $78FDW  $59 $C7 $44 $34 $6A00W  $C7 $44 $32 $5E00W
             $C7 $04 $000FW  $C7 $44 $28 $0029W  $C7 $44 $2A $0000W  $5E $5D $C3

#Vizard has longer death sequence
%patch $4732 $04


#################################################
#Moving platform birds				#
#################################################

#Initiation codes
%patch $3AFD $56 $57 $E8 $01A7W  $59 $59 $E9 $00B3W	#Goes to still bird (Code at $3AFD + $1A7 + 5 = $3CA9)
%patch $3B07 $56 $57 $E8 $01D1W  $59 $59 $E9 $00A9W	#Goes to H bird (Code at $3B07 + $1D1 + 5 = $3CDD)
%patch $3B11 $56 $57 $E8 $01FFW  $59 $59 $E9 $009FW	#Goes to V bird (Code at $3B11 + $1FF + 5 = $3D15)

#Still platform spawn - Incomplete
%patch $3CA9 $55 $8B $EC $56 $E8 $230DW  $8B $F0 $C7 $04 $000AW  $8B $46 $04 #Sprite type = 10
             $99 $B1 $0C $E8 $AF02W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $AEF3W  $05 $00 $FC $83 $D2 $FF $89 $44 $08 $89 $54
             $0A $E9 $0068W

#Horizontal platform spawn - Incomplete
%patch $3CDD $55 $8B $EC $56 $E8 $22D9W  $8B $F0 $C7 $04 $000AW  $8B $46 $04 #Sprite type = 10
             $99 $B1 $0C $E8 $AECEW  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $AEBFW  $05 $00 $FC $83 $D2 $FF $89 $44 $08 $89 $54 #Speed = 76
             $0A $C7 $44 $20 $004BW  $EB $30

#Vertical platform spawn-completes previous two
%patch $3D15 $55 $8B $EC $56 $E8 $22A1W  $8B $F0 $C7 $04 $000AW  $8B $46 $04 #Sprite type = 10
             $99 $B1 $0C $E8 $AE96W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $AE87W  $89 $44 $08 $89 $54 $0A $C7 $44 $22 $004BW  #Behavior = $4C47
             $C7 $44 $34 $6A00W  $C7 $44 $28 $0035W  $C7 $44 $32 $4C47W  $5E #Collision $6A00, Sprite = 35, Speed = 76
             $5D $C3

#Bird behavior; don't pause when hitting stuff
%patch $4C47 $55 $8B $EC $56 $A1 $61 $53 $B1 $05 $D3 $E8 $25 $0001W  $05 $0035W
                 $A3 $38 $99 $E8 $1699W  $8B $F0 $F7 $C6 $02 $00 $74 $06 $C7
             $06 $32 $99 $FFB5W  $F7 $C6 $08 $00 $74 $06 $C7 $06 $32 $99 $004BW 
                 $F7 $C6 $04 $00 $74 $06 $C7 $06 $30 $99 $FFB5W  $F7 $C6 $01
             $00 $74 $06 $C7 $06 $30 $99 $004BW  $5E $5D $C3


#Bird behavior (Incomplete, uses differing animations to boat's then goes to boat code)
%patch $4C47 $55 $8B $EC $56 $A1 $61 $53 $B1 $05 $D3 $E8 $25 $0001W  $05 $0035W
                 $A3 $38 $99 $EB $14


#################################################
#Boat (Different platform)			#
#################################################

#Boat initiation (Code at $3B1B + $25F + 5 = $3D9E)
%patch $3B1B $56 $57 $E8 $027EW  $59 $59 $E9 $0095W

#Boat spawn -complete (Not worth jumping)
%patch $3D9E $55 $8B $EC $56 $E8 $2218W  $8B $F0 $C7 $04 $000AW  $8B $46 $04 #Sprite type = 10
             $99 $B1 $0C $E8 $AE0DW  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $ADFEW  $89 $44 $08 $89 $54 $0A $C7 $44 $20 $004BW  #Behavior = $4C47
             $C7 $44 $34 $6A00W  $C7 $44 $28 $0034W  $C7 $44 $32 $4C5DW  $5E #Collision $6A00, Sprite = 35, Speed = 76
             $5D $C3

#Boat behavior; don't pause when hitting stuff, move l-r or u-d
%patch $4C5D $55 $8B $EC $56 $A1 $61 $53 $B1 $05 $D3 $E8 $25 $0000W  $05 $0034W
                 $A3 $38 $99 $E8 $1683W  $8B $F0 $F7 $C6 $02 $00 $74 $06 $C7
             $06 $32 $99 $FFB5W  $F7 $C6 $08 $00 $74 $06 $C7 $06 $32 $99 $004BW 
                 $F7 $C6 $04 $00 $74 $06 $C7 $06 $30 $99 $FFB5W  $F7 $C6 $01
             $00 $74 $06 $C7 $06 $30 $99 $004BW  $5E $5D $C3



#################################################
#High point items (Crown, gem, chest)		#
#################################################

#Initiation codes
%patch $3B25 $56 $57 $E8 $02B6W  $59 $59 $E9 $008BW	#Goes to Crown (Code at $3B25 + $2B6 + 5 = $3DE0)
%patch $3B2F $56 $57 $E8 $02E9W  $59 $59 $E9 $0081W	#Goes to Gem (Code at $3B2F + $2E9 + 5 = $3E1D)
%patch $3B39 $56 $57 $E8 $031CW  $59 $59 $EB $78	#Goes to Chest (Code at $3B39 + $31C + 5 = $3E5A)

#Spawn crown
%patch $3DE0 $55 $8B $EC $56 $E8 $21D6W  $8B $F0 $C7 $04 $000DW  $8B $46 $04 #Sprite type = 13
             $99 $B1 $0C $E8 $ADCBW  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $ADBCW  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $6A00W  #Behavior = $6A00W
             $C7 $44 $34 $4E02W  $C7 $44 $28 $0037W  $5E $5D $C3             #Collision $4E02, 

#Spawn chest
%patch $3E1D $55 $8B $EC $56 $E8 $2199W  $8B $F0 $C7 $04 $000DW  $8B $46 $04 #Sprite type = 13
             $99 $B1 $0C $E8 $AD8EW  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $AD7FW  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $6A00W  #Behavior = $6A00W
             $C7 $44 $34 $4E2CW  $C7 $44 $28 $0038W  $5E $5D $C3             #Collision $4E2C

#Spawn gem (All 3 are identical in form)
%patch $3E5A $55 $8B $EC $56 $E8 $215CW  $8B $F0 $C7 $04 $000DW  $8B $46 $04 #Sprite type = 13
             $99 $B1 $0C $E8 $AD51W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $AD42W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $6A00W  #Behavior = $6A00W
             $C7 $44 $34 $4E17W  $C7 $44 $28 $0039W  $5E $5D $C3             #Collision $4E17

#Crown collision: + 10000
%patch $4E02 $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $01 $75 $44 $B8
             $2710W  $50 $EB $28

#Gem collision: + 5000
%patch $4E17 $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $01 $75 $2F $B8
             $1388W  $50 $EB $13

#Chest collision (Completes previous two codes): + 20000
%patch $4E2C $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $01 $75 $1A $B8
             $4E20W  $50 $E8 $BF83W  $59 $B8
             $0012W  $50 $E8 $7B1FW  $59 $C7 $44 $34 $6A00W  $C7 $44 $32 $5DA9W
                 $5E $5D $C3

#Fall a period then vanish behavior (Used by many things)
%patch $5DA9 $55 $8B $EC $C7 $06 $10 $99 $0013W  $A1 $3A $99 $03 $06 $40 $5D
             $A3 $3A $99 $E8 $04F5W  $83 $3E $3A $99 $7C $7E $06 $C7 $06 $10 $99 $0000W  $5D $C3



#################################################
#Hawk: Chase Keen				#
#################################################

#Hawk initation
%patch $3B42 $56 $57 $E8 $0350W  $59 $59 $EB $6F  #Goes to Hawk (Code at $3B42 + $350 + 5 = $3E97)

#Spawn hawk
%patch $3E97 $55 $8B $EC $56 $E8 $211FW  $8B $F0 $C7 $04 $0002W  $8B $46 $04 #Sprite type = 2
             $99 $B1 $0C $E8 $AD14W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $AD05W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $4E67W  #Behavior = $4E67W
             $C7 $44 $34 $4ED4W  $5E $5D $C3             #Collision $4ED4

#Keen chaser behavior - Hawk (Needs Vizard code to complete)
%patch $4E67 $55 $56 $57 $A1 $61 $53 $C1 $E8 $04 $83 $E0 $02 $83 $C0 $4B $EB $20

#Chase Keen behavior - Bat (Needs Vizard code to complete)
%patch $4E78 $55 $56 $57 $A1 $61 $53 $C1 $E8 $03 $83 $E0 $02 $83 $C0 $4C $EB $0F

#Chase Keen behavior, Vizard shot
%patch $4E89 $55 $56 $57 $A1 $61 $53 $C1 $E8 $03 $83 $E0 $02 $83 $C0 $3A $A3
             $38 $99 $66 $A1 $14 $99 $66 $3B $06 $0A $71 $7F $08 $C7 $06 $30
             $99 $003CW  $EB $06 $C7 $06 $30 $99 $FFC4W  $66 $A1 $18 $99 $66
             $3B $06 $0E $71 $7F $08 $C7 $06 $32 $99 $003CW  $EB $06 $C7 $06
             $32 $99 $FFC4W  $E8 $1427W  $5F $5E $5D $C3

#Hawk collision (Shootable, falls down)
%patch $4ED4 $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $0F $75 $17 $B8
             $0016W  $50 $E8 $7A7FW  $59 $C7 $44 $34 $6A00W  $C7 $44 $32 $5DA9W
             $C7 $44 $28 $004FW  $5E $5D $C3


#################################################
#Bat: Also chase Keen				#
#################################################

#Bat initiation
%patch $3B4B $56 $57 $E8 $037FW  $59 $59 $EB $66	#Goes to Bat (Code at $3B4B + $516 + 5 = $3ECF)

#Spawn bat
%patch $3ECF $55 $8B $EC $56 $E8 $20E7W  $8B $F0 $C7 $04 $0002W  $8B $46 $04 #Sprite type = 2
             $99 $B1 $0C $E8 $ACDCW  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $ACCDW  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $4E78W  #Behavior = $4E78W
             $C7 $44 $34 $4EFDW  $5E $5D $C3             #Collision $4EFD

#Bat collision (Shootable, falls down)
%patch $4EFD $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $0F $75 $17 $B8
             $0014W  $50 $E8 $7A56W  $59 $C7 $44 $34 $6A00W  $C7 $44 $32 $5DA9W
             $C7 $44 $28 $003BW  $5E $5D $C3



#################################################
#Doors						#
#################################################

#Door initation
%patch $3B54 $56 $57 $E8 $03AEW  $59 $59 $EB $5D	#Goes to Door (Code at $3B54 + $3AE + 5 = $3F07)

#Door spawn
%patch $3F07 $55 $8B $EC $56 $E8 $20AFW  $8B $F0 $C7 $04 $0004W  $8B $46 $04 #Sprite type = 4
             $99 $B1 $0C $E8 $ACA4W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $AC95W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $6A00W  #Behavior = $6A00W
             $C7 $44 $34 $4F26W  $C7 $44 $28 $0033W  $5E $5D $C3             #Collision $4EFD

#Door collision (Respond to Meep type)
%patch $4F26 $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $05 $75 $18 $B8
             $0021W  $50 $E8 $7A2DW  $59 $C7 $44 $34 $6A00W  $C7 $44 $32 $5DA9W
             $C7 $87 $9D1EW  $0000W  $5E $5D $C3

#Yellow lock initation (Plus others)
%patch $3B5D $56 $57 $E8 $03E2W  $59 $59 $EB $54	#Goes to Y lock ($3B5D + $3E2 + 5 = $3F44)
%patch $3B66 $56 $57 $E8 $0416W  $59 $59 $EB $4B	#Goes to R lock ($3B66 + $416 + 5 = $3F81)
%patch $3B6F $56 $57 $E8 $044AW  $59 $59 $EB $42	#Goes to G lock ($3B6F + $44A + 5 = $3FBE)
%patch $3B78 $56 $57 $E8 $047EW  $59 $59 $EB $39	#Goes to B lock ($3B6F + $47E + 5 = $3FFB)

#Yellow lock spawn
%patch $3F44 $55 $8B $EC $56 $E8 $2072W  $8B $F0 $C7 $04 $0001W  $8B $46 $04 #Sprite type = 7
             $99 $B1 $0C $E8 $AC67W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $AC58W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $6A00W  #Behavior = $6A00W
             $C7 $44 $34 $4FAAW  $C7 $44 $28 $0021W  $5E $5D $C3             #Collision $4FAA

#Red lock spawn
%patch $3F81 $55 $8B $EC $56 $E8 $2035W  $8B $F0 $C7 $04 $0007W  $8B $46 $04 #Sprite type = 7
             $99 $B1 $0C $E8 $AC2AW  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $AC1BW  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $6A00W  #Behavior = $6A00W
             $C7 $44 $34 $4F50W  $C7 $44 $28 $0022W  $5E $5D $C3             #Collision $4F50

#Green lock spawn
%patch $3FBE $55 $8B $EC $56 $E8 $1FF8W  $8B $F0 $C7 $04 $0007W  $8B $46 $04 #Sprite type = 7
             $99 $B1 $0C $E8 $ABEDW  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $ABDEW  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $6A00W  #Behavior = $6A00W
             $C7 $44 $34 $4F6EW  $C7 $44 $28 $0023W  $5E $5D $C3             #Collision $4F6E

#Blue lock spawn
%patch $3FFB $55 $8B $EC $56 $E8 $1FBBW  $8B $F0 $C7 $04 $0007W  $8B $46 $04 #Sprite type = 7
             $99 $B1 $0C $E8 $ABB0W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $ABA1W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $6A00W  #Behavior = $6A00W
             $C7 $44 $34 $4F8CW  $C7 $44 $28 $0024W  $5E $5D $C3             #Collision $4F8C

#Red lock collision (Respond to Keen, IF he has red key - incomplete, uses yellow code
%patch $4F50 $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $01 $75 $75 $83
             $3E $9D20W  $01 $75 $6E $C7 $06 $9D20W  $0000W  $EB $58

#Green lock collision (Respond to Keen, IF he has green key - incomplete, uses yellow code
%patch $4F6E $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $01 $75 $57 $83
             $3E $9D22W  $01 $75 $50 $C7 $06 $9D22W  $0000W  $EB $3A

#Blue lock collision (Respond to Keen, IF he has blue key - incomplete, uses yellow code
%patch $4F8C $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $01 $75 $39 $83
             $3E $9D24W  $01 $75 $32 $C7 $06 $9D24W  $0000W  $EB $1C

#Yellow lock collision (Respond to Keen, IF he has yellow key)
%patch $4FAA $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $01 $75 $1B $83
             $3E $9D1EW  $01 $75 $14 $C7 $06 $9D1EW  $0000W
             $C7 $44 $34 $6A00W  $C7 $44 $32 $7E05W  $C7 $04 $0005W  $5E $5D $C3


#################################################
#TNT (Falling bomb)				#
#################################################

#TNT initiation
%patch $3B8A $56 $57 $E8 $04F6W  $59 $59 $EB $27

#TNT spawn (Will fall)
%patch $4085 $55 $8B $EC $56 $E8 $1F31W  $8B $F0 $C7 $04 $0002W  $8B $46 $04 #Sprite type = 2
             $99 $B1 $0C $E8 $AB26W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $AB17W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $4E58W  #Behavior = $4E58W
             $C7 $44 $34 $5DCEW  $C7 $44 $28 $0028W  $5E $5D $C3             #Collision $4F8C

#TNT behvior, fall and land
%patch $4E58 $55 $8B $EC $FF $06 $3A $99 $E8 $1452W $E8 $1492W  $5D $C3


#TNT collision (Explode on any contact, become lethal to Keen property)
%patch $5DCE $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $00 $74 $20 $B8
             $002DW  $50 $E8 $6B85W  $59 $C7 $44 $34 $6A00W  $C7 $44 $32 $5E00W
             $C7 $04 $000FW  $C7 $44 $28 $0029W  $C7 $44 $2A $0000W  $5E $5D $C3

#Explosion, remain a while before becoming a zapzot
%patch $5E00 $55 $8B $EC $A1 $3A $99 $03 $06 $40 $5D $A3 $3A $99 $3D $0030W
             $7E $12 $C7 $06 $3A $99 $0000W  $C7 $06 $38 $99 $0069W  $C7 $06
             $42 $99 $7E05W  $5D $C3


#################################################
#SharKey (Meep equivalent)			#
#################################################

#Sharky initiation
%patch $3B81 $56 $57 $E8 $04B2W  $59 $59 $EB $30

#Sharky spawn -3D46
%patch $4038 $55 $8B $EC $56 $E8 $1F7EW  $8B $F0 $C7 $04 $0005W  $8B $46 $04 #Sprite type = 5
             $99 $B1 $0C $E8 $AB73W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $AB64W  $05 $00 $08 $83 $D2 $00 $89 $44 $08 $89 $54
             $0A $C7 $44 $32 $4746W  $C7 $44 $34 $4898W  $C7 $44 $24 $0001W  #Behavior = $4746 Collision = $4898, health = 1
             $C7 $44 $20 $0041W  $C7 $44 $28 $0078W  $5E $5D $C3 #Speed +-65, sprite = 78

#SharKey walking code - walk off edges
%patch $4746 $55 $8B $EC $56 $83 $3E $30 $99 $00 $7E $08 $C7 $06 $38 $99 $006FW
                 $EB $06 $C7 $06 $38 $99 $006BW  $A1 $61 $53 $B1 $04 $D3 $E8
             $25 $0001W  $8B $16 $38 $99 $03 $D0 $89 $16 $38 $99 $E8 $83CEW
             $3B $06 $40 $5D $73 $17 $A1 $30 $99 $A3 $3E $99 $33 $C0 $A3 $30
             $99 $A3 $3C $99 $A3 $3A $99 $C7 $06 $42 $99 $47D3W  $E8 $1B1EW
             $E8 $1B5EW  $8B $F0 $F7 $C6 $02 $00 $75 $17 $83 $3E $30 $99 $00
             $7E $08 $C7 $06 $30 $99 $0041W  $EB $06 $C7 $06 $30 $99 $FFBFW
             $90 $90 $F7 $C6 $04 $00 $74 $06 $C7 $06 $30 $99 $FFBFW  $F7 $C6
             $01 $00 $74 $06 $C7 $06 $30 $99 $0041W  $5E $5D $C3

#SharKey shooting code (Shoots likie Keen)
%patch $47D3 $55 $8B $EC $56 $83 $3E $3E $99 $00 $7D $08 $C7 $06 $38 $99 $0073W
                 $EB $06 $C7 $06 $38 $99 $0074W  $A1 $3A $99 $03 $06 $40 $5D
             $A3 $3A $99 $83 $3E $3A $99 $3C $7D $03 $E9 $0095W  $83 $3E $3C
             $99 $00 $75 $7B $C7 $06 $3C $99 $0001W  $B8 $002BW  $50 $E8 $8155W
                 $59 $E8 $17A5W  $8B $F0 $83 $3E $3E $99 $00 $7D $1D $A1 $16
             $99 $8B $16 $14 $99 $89 $54 $04 $89 $44 $06 $B8 $0066W  $89 $44
             $2A $89 $44 $28 $C7 $44 $20 $FB50W  $EB $22 $A1 $16 $99 $8B $16
             $14 $99 $81 $C2 $00 $10 $15 $0000W  $89 $54 $04 $89 $44 $06 $C7
             $44 $20 $04B0W  $B8 $0066W  $89 $44 $2A $89 $44 $28 $A1 $1A $99
             $8B $16 $18 $99 $81 $C2 $00 $0A $15 $0000W  $89 $54 $08 $89 $44
             $0A $C7 $44 $32 $7E29W  $C7 $44 $34 $46C6W  $C7 $04 $0011W  $83
             $3E $3A $99 $50 $7E $0C $A1 $3E $99 $A3 $30 $99 $C7 $06 $42 $99
             $4746W  $5E $5D $C3

#Sharkey shot code
%patch $4898 $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $0F $75 $28 $FF
             $4C $24 $74 $02 $EB $21 $B8 $0027W  $50 $E8 $B4 $80 $59 $C7 $44
             $2A $0000W  $C7 $44 $2C $0002W  $C7 $44 $28 $0075W  $C7 $44 $34
             $6A00W  $C7 $44 $32 $7EC0W  $5E $5D $C3

#Intertwine Vortininja and Meep
#Turn to Meep on landing
%patch $49C8 $4746W

#Meep turn to Vort-sit after shooting
%patch $4893 $48F7W

#Standing Ninja automatically goes to Meep walk
%patch $4973 $EB $02 $EB $0F $C7 $06 $42 $99 $4746W  $8B $E5 $5D $C3

#Synch animations between Meep and Ninja
%patch $492A $006FW #Standing right
%patch $491C $006BW #Standing left

#Jumping Sharkey bounces off walls (Most of the time.)
%patch $49B0 $C7 $06 $30 $99 $FF9FW
%patch $49A8 $C7 $06 $30 $99 $0061W


#################################################
#Canons (For decoration)			#
#################################################

#Left Canon initiation
%patch $3BD4 $56 $57 $E8 $04E9W  $59 $59 $EB $DD

#Right Canon initiation
%patch $3BDD $56 $57 $E8 $051DW  $59 $59 $EB $D4

#Left canon spawn #3D
%patch $40C2 $55 $8B $EC $56 $E8 $1EF4W  $8B $F0 $C7 $04 $0007W  $8B $46 $04 #Sprite type = 7
             $99 $B1 $0C $E8 $AAE9W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $AADAW  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $4E58W  #Behavior = $4E58W
             $C7 $44 $34 $6A00W  $C7 $44 $28 $0026W  $5E $5D $C3             #Collision: none

#Right canon spawn
%patch $40FF $55 $8B $EC $56 $E8 $1EB7W  $8B $F0 $C7 $04 $0007W  $8B $46 $04 #Sprite type = 7
             $99 $B1 $0C $E8 $AAACW  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $AA9DW  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $4E58W  #Behavior = $4E58W
             $C7 $44 $34 $6A00W  $C7 $44 $28 $0027W  $5E $5D $C3             #Collision: none



#################################################
#Cannon firerers (Vorticon shooters)		#
#################################################

#Left Canon shooter initiation
%patch $3BE6 $56 $57 $E8 $13ECW  $59 $59 $EB $CB

#Right Canon shooter initiation
%patch $3BEF $56 $57 $E8 $1420W  $59 $59 $EB $C2

#Left canon shooter spawn
%patch $4FD7 $55 $8B $EC $56 $E8 $0FDFW  $8B $F0 $C7 $04 $0002W  $8B $46 $04 #Sprite type = 2
             $99 $B1 $0C $E8 $9BD4W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $9BC5W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $5100W  #Behavior = $5100W
             $C7 $44 $28 $0042W  $C7 $44 $34 $42D0W  $EB $3B                 #Use next vort code

#Right canon shooter spawn
%patch $5014 $55 $8B $EC $56 $E8 $0FA2W  $8B $F0 $C7 $04 $0002W  $8B $46 $04 #Sprite type = 2
             $99 $B1 $0C $E8 $9B97W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $9B88W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $51BFW  #Behavior = $51BFW
             $C7 $44 $34 $42D0W  $C7 $44 $28 $0046W  $C7 $44 $24 $0001W  $5E #Collision: vorticon h=1
             $5D $C3

#Left canon shooter make a shot
%patch $5088 $55 $8B $EC $56 $B8 $002BW  $50 $E8 $78D6W
                 $59 $E8 $0F26W  $8B $F0 $A1 $16 $99 $8B $16 $14 $99 $81 $C2
             $00 $EA $15 $FFFFW  $89 $54 $04 $89 $44 $06 $C7 $44 $20 $FE70W
             $B8 $0025W  $89 $44 $2A $89 $44 $28 $A1 $1A $99 $8B $16 $18 $99
             $81 $C2 $00 $08 $15 $0000W  $89 $54 $08 $89 $44 $0A $C7 $44 $32
             $5120W  $C7 $44 $34 $6A00W  $C7 $04 $0011W  $C7 $44 $22 $FE90W
             $A1 $3E $99 $A3 $30 $99 $C7 $06 $42 $99 $5100W  $C7 $06 $3A $99
             $0000W  $5E $5D $C3

#Left canon shooter pause behavior
%patch $5100 $55 $8B $EC $A1 $3A $99 $03 $06 $40 $5D $A3 $3A $99 $3D $0130W
             $7E $06 $C7 $06 $42 $99 $5088W  $E8 $1199W  $E8 $11D9W  $5D $C3

#Canonball behavior
%patch $5120 $55 $8B $EC $56 $E8 $11D0W  $8B $F0 $0B $F6 $74 $20 $B8 $0025W     #Play sound
             $50 $E8 $7835W  $59 $C7 $06 $10 $99 $0012W  $C7 $06 $42 $99 $7E05W #Set sprite type and behavior
                 $C7 $06 $3A $99 $0000W  $C7 $06 $38 $99 $0029W  $5E  $5D $C3    #Set animation

#Right canon shooter make a shot
%patch $5150 $55 $8B $EC $56 $B8 $002BW  $50 $E8 $780EW
                 $59 $E8 $0E5EW  $8B $F0 $A1 $16 $99 $8B $16 $14 $99 $81 $C2
             $00 $1C $15 $0000W  $89 $54 $04 $89 $44 $06 $C7 $44 $20 $0190W
             $B8 $0025W  $89 $44 $2A $89 $44 $28 $A1 $1A $99 $8B $16 $18 $99
             $81 $C2 $00 $08 $15 $0000W  $89 $54 $08 $89 $44 $0A $C7 $44 $32
             $5120W  $C7 $44 $34 $6A00W  $C7 $04 $0011W  $C7 $44 $22 $FE90W
             $A1 $3E $99 $A3 $30 $99 $C7 $06 $42 $99 $51BFW  $C7 $06 $3A $99
             $0000W  $5E $5D $C3

#Right canon shooter pause behavior
%patch $51BF $55 $8B $EC $A1 $3A $99 $03 $06 $40 $5D $A3 $3A $99 $3D $0130W
             $7E $06 $C7 $06 $42 $99 $5150W  $E8 $10DAW  $E8 $111AW  $5D $C3



#################################################
#Secret level kiwi snail-thing			#
#################################################

#Snail initiation
%patch $3BF8 $56 $57 $E8 $15E2W  $59 $59 $EB $B9

#Snail spawn #3D
%patch $51DF $55 $8B $EC $56 $E8 $0DD7W  $8B $F0 $C7 $04 $0002W  $8B $46 $04 #Sprite type = 2
             $99 $B1 $0C $E8 $99CCW  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $99BDW  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $4E58W  #Behavior = fall
             $C7 $44 $34 $5221W  $C7 $44 $28 $002EW  $C7 $44 $24 $0001W  $5E #Collision: fall, h=1
             $5D $C3

#Snail collision (Explode on any contact bar Keen, become lethal to Keen property)
%patch $5221 $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $02 $7E $20 $B8
             $0023W  $50 $E8 $7732W  $59 $C7 $44 $34 $6A00W  $C7 $44 $32 $5E00W
             $C7 $04 $000FW  $C7 $44 $28 $0029W  $C7 $44 $2A $0000W  $5E $5D $C3


#################################################
#Bosses (Sit, open windows)			#
#################################################

#Disable CTSpace
%patch $114E $EB $16

#Change press any key animation to be more useful
%patch $2817 $17 #Last frame
%patch $27E0 $10 #First frame

#Increment pogo, play sound on boss note display, extra pause window for odd error
%patch $0E77 $FF $06 $9D22W  $B8 $0003W  $50 $E8 $BAE7W  $59 $E8 $AD7AW



#################################################
#Levellass (Sit, vanish)			#
#################################################

#Lass initiation
%patch $3C01 $56 $57 $E8 $164DW  $59 $59 $EB $B0

#Lass spawn
%patch $5253 $55 $8B $EC $56 $E8 $0D63W  $8B $F0 $C7 $04 $0007W  $8B $46 $04 #Sprite type = 7
             $99 $B1 $0C $E8 $9958W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $9949W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $6A00W  #Behavior = none
             $C7 $44 $34 $5295W  $C7 $44 $28 $002BW  $C7 $44 $24 $0001W  $5E #Collision: lassnote, h=1
             $5D $C3

#Lass collision (Keen touch, make note)
%patch $5295 $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $02 $7D $EE $B8
             $0005W  $50 $B8 $0019W  $50 $E8 $D389W  $59 $59 $B8 $286DW  $50
             $E8 $D58BW  $59 $C7 $44 $32 $6A00W  $C7 $44 $34 $5DA9W  $C7 $44
             $28 $003EW  $E9 $BBACW

#Lass note
%patch $1C08D "'Fight Keen to the last?'" $0A
              "To heck with that, I'm" $0A
              "outta here!" $0A $0A
              "-Lass" $00


#################################################
#Spleen (Also sit, window)			#
#################################################

#Lass initiation
%patch $3C0A $56 $57 $E8 $16BCW  $59 $59 $EB $A7

#Spleen spawn
%patch $52CB $55 $8B $EC $56 $E8 $0CEBW  $8B $F0 $C7 $04 $0007W  $8B $46 $04 #Sprite type = 7
             $99 $B1 $0C $E8 $98E0W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $98D1W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $9030W  #Behavior = Spleenbounce
             $C7 $44 $34 $530DW  $C7 $44 $28 $002AW  $C7 $44 $24 $0001W  $5E #Collision: lassnote, h=1
             $5D $C3

#Spleen behavior, bounce; uses ->545B KR beh
%patch $9030 $55 $8B $EC $56 $C7 $06 $38 $99 $002AW  $A1 $61 $53 $B1 $04 $D3
             $E8 $25 $0000W  $E9 $C414W

#Spleen collision (Keen touch, make note)
%patch $530D $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $02 $7D $EE $B8
             $0005W  $50 $B8 $0019W  $50 $E8 $D311W  $59 $59 $B8 $28B1W  $50
             $E8 $D513W  $59 $C7 $44 $32 $6A00W  $C7 $44 $34 $5DA9W  $C7 $44
             $28 $003EW  $E9 $BB34W

#Spleen talk
%patch $1C0D1 "I uh... thought I'd have" $0A
              "more built by now..." $0A $0A
              "Uh... NOT THE FACE!" $00


#################################################
#Xky (Sit, blah blah blah)			#
#################################################

#Xky initiation
%patch $3C13 $56 $57 $E8 $172BW  $59 $59 $EB $9E

#Xky spawn
%patch $5343 $55 $8B $EC $56 $E8 $0C73W  $8B $F0 $C7 $04 $0007W  $8B $46 $04 #Sprite type = 7
             $99 $B1 $0C $E8 $9868W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $9859W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $4E58W  #Behavior = fall
             $C7 $44 $34 $5385W  $C7 $44 $28 $002CW  $C7 $44 $24 $0001W  $5E #Collision: lassnote, h=1
             $5D $C3

#Xky collision (Keen touch, make note)
%patch $5385 $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $02 $7D $EE $B8
             $0005W  $50 $B8 $0019W  $50 $E8 $D299W  $59 $59 $B8 $28F4W  $50
             $E8 $D49BW  $59 $C7 $44 $32 $6A00W  $C7 $44 $34 $5DA9W  $C7 $44
             $28 $003EW  $E9 $BABCW

#Xky talk
%patch $1C114 "GUARDS! Uh... guards...?" $0A $0A
              "Oh I'm so screwed." $00


#################################################
#KR - actually dangerous			#
#################################################

#KR initiation
%patch $0E22 $56 $57 $E8 $4594W  $59 $59 $E9 $2D8EW

#KR spawn
%patch $53BB $55 $8B $EC $56 $E8 $0BFBW  $8B $F0 $C7 $04 $0002W  $8B $46 $04 #Sprite type = 2
             $99 $B1 $0C $E8 $97F0W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $97E1W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $5438W  #Behavior = bounce
             $C7 $44 $34 $5402W  $C7 $44 $28 $0052W  $C7 $44 $24 $0001W  $C7 #Collision: bombable, h=1
             $44 $20 $004BW $5E $5D $C3

#KR collision (Makes note if type 2 hits)
%patch $5402 $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $02 $75 $EE $B8
             $0005W  $50 $B8 $0019W  $50 $E8 $D21CW  $59 $59 $B8 $2921W  $50
             $E8 $D41EW  $59 $C7 $44 $32 $5402W  $C7 $04 $0007W  $C7 $44
             $28 $003EW  $E9 $BA40W

#KR behavior, dash back and forth rapidly, bounce
%patch $5438 $55 $8B $EC $56 $83 $3E $30 $99 $00 $7E $08 $C7 $06 $38 $99 $0052W
                 $EB $06 $C7 $06 $38 $99 $0050W  $A1 $61 $53 $B1 $04 $D3 $E8
             $25 $0001W  $8B $16 $38 $99 $03 $D0 $89 $16 $38 $99 $E8 $0E4CW
             $E8 $0E8CW  $8B $F0 $F7 $C6 $02 $00 $74 $06 $C7 $06 $32 $99 $FF05W
                 $F7 $C6 $08 $00 $74 $06 $C7 $06 $32 $99 $008BW  $F7 $C6 $04
             $00 $74 $06 $C7 $06 $30 $99 $FF75W  $F7 $C6 $01 $00 $74 $06 $C7
             $06 $30 $99 $008BW  $5E $5D $C3

#KR talk
%patch $1C141 "NOOO! Explosions!" $0A $0A
              "My one weakness!" $00


#################################################
#Metroid (For Ridley's castle secret level	#
#################################################

#Metroid initiation
%patch $0E2C $56 $57 $E8 $466FW  $59 $59 $E9 $2D84W

#Metroid spawn
%patch $54A0 $55 $8B $EC $56 $E8 $0B16W  $8B $F0 $C7 $04 $0002W  $8B $46 $04 #Sprite type = 2
             $99 $B1 $0C $E8 $970BW  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $96FCW  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $54E2W  #Behavior = chase Keen
             $C7 $44 $34 $6A00W  $C7 $44 $28 $002DW  $5E $5D $C3 #Collision: none

#Chase Keen behavior - Metroid (Needs Vizard code to complete)
%patch $54E2 $55 $56 $57 $A1 $61 $53 $C1 $E8 $03 $83 $E0 $00 $83 $C0 $2D $E9 $F9A4W



#################################################
#Pie-Rat (Kinda Foobish)			#
#################################################

#Rat initiation
%patch $0E40 $56 $57 $E8 $0716W  $59 $59 $E9 $2D70W

#Rat spawn
%patch $155B $55 $8B $EC $56 $E8 $4A5BW  $8B $F0 $C7 $04 $0007W  $8B $46 $04 #Sprite type = 7
             $99 $B1 $0C $E8 $D650W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $D641W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $4A0CW  #Behavior = $4A0C
             $C7 $44 $34 $15A2W  $C7 $44 $24 $0001W  $C7 $44 $20 $FFCEW  $C7 #Collision $4B7E, health = 1
             $44 $28 $005FW  $5E $5D $C3 #Speed +-50, sprite = 5F

#Rat collision (Die on any contact, bar self, if Keen, give 5000 points)
%patch $15A2 $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $07 $74 $14 $83
             $3F $01 $75 $08 $B8 $1388W  $50 $E8 $F808W  $59 $B8 $0022W  $50
             $E9 $3882W  $5E $5D $C3

#Change animations to fit new sprites
%patch $4A1E $0061W #Walking right
%patch $4A26 $005FW #Walking left
%patch $4A30 $01    #Frames used -1

%patch $4AE7 $0061W #Running right
%patch $4AEF $005FW #Running left
%patch $4AFB $01    #Frames used -1

%patch $4B3D $0063W #Scared
%patch $4B3A $01     #Frames used -1


#################################################
#Octogotchi					#
#################################################

#Octo initiation
%patch $0E4A $56 $57 $E8 $3D2FW  $59 $59 $E9 $2D66W

#Octo spawn (2 bytes short of code space! Yeaaaaahh!)
%patch $4B7E $55 $8B $EC $56 $E8 $1438W  $8B $F0 $C7 $04 $0005W  $8B $46 $04 #Sprite type = 5
             $99 $B1 $0C $E8 $A02DW  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $A01EW  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $15C8W  #Behavior = $15C8W
             $C7 $44 $34 $15DAW  $C7 $44 $24 $0001W  $5E $5D $C3             #Collision $15DA, h = 1

#Octo behavior (Chase Keen, anim = 6; needs Vortizard code to complete)
%patch $15C8 $55 $56 $57 $A1 $61 $53 $C1 $E8 $04 $83 $E0 $00 $83 $C0 $06 $E9 $38BEW

#Octo collision, fall die if shot, goto sprite 7
%patch $15DA $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $0F $75 $17 $B8
             $0016W  $50 $E8 $B379W  $59 $C7 $44 $34 $6A00W  $C7 $44 $32 $5DA9W
             $C7 $44 $28 $0007W  $5E $5D $C3


#################################################
#Lethality for submerged level			#
#################################################

#Lethality initiation
%patch $0E54 $56 $57 $E8 $07AAW  $59 $59 $E9 $2D5CW

#Lethality spawn 
%patch $1603 $55 $8B $EC $56 $E8 $49B3W  $8B $F0 $C7 $04 $0002W  $8B $46 $04 #Sprite type = 7
             $99 $B1 $0C $E8 $D5A8W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $D599W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $163BW  #Behavior = $15C8W
             $C7 $44 $34 $6A00W  $5E $5D $C3                                 #Collision $6A00

#Lethality behavior, chase Keen rapidly, through all tiles (So always present, also invisible)
%patch $163B $55 $56 $57 $A1 $61 $53 $C1 $E8 $03 $83 $E0 $00 $83 $C0 $3E $A3
             $38 $99 $66 $A1 $14 $99 $66 $3B $06 $0A $71 $7F $08 $C7 $06 $30
             $99 $023CW  $EB $06 $C7 $06 $30 $99 $FDC4W  $66 $A1 $18 $99 $66
             $3B $06 $0E $71 $7F $08 $C7 $06 $32 $99 $023CW  $EB $06 $C7 $06
             $32 $99 $FDC4W  $E8 $4C75W  $5F $5E $5D $C3


#################################################
#Ceilick (Complex boss!)			#
#################################################

#Ceilick initiation
%patch $0E36 $56 $57 $E8 $46B9W  $59 $59 $E9 $2D7AW

#Ceilick spawn
%patch $54F4 $55 $8B $EC $56 $E8 $0AC2W  $8B $F0 $C7 $04 $0004W  $8B $46 $04 #Sprite type = 4
             $99 $B1 $0C $E8 $96B7W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $96A8W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $9047W  #Behavior = Ceilwait
             $C7 $44 $34 $1718W  $C7 $44 $28 $0002W  $C7 $44 $24 $0002W  $5E #Collision: bombable, h=1
             $5D $C3

#Ceilick behavior, moving platform (But sits still!)
%patch $553B $55 $8B $EC $56 $A1 $61 $53 $B1 $05 $D3 $E8 $25 $0001W  $05 $0002W $E9 $F709W

#Ceilick collision (Give 200K pts, goto explosion, give gold key)
%patch $1718 $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $0F $75 $38 $B8
             $0D40W  $50 $E8 $F697W  $59 $B8 $0012W  $50 $E8 $B233W  $59 $FF #Round to 200K
             $06 $9D4CW  $FF $06 $9D4CW  $FF $06 $9D1AW  $C7 $44 $34 $6A00W
                 $C7 $44 $32 $5E00W  $C7 $44 $28 $0029W  $C7 $44 $2A $0000W
             $FF $06 $9D1EW  $FF $06 $9D4CW  $5E $5D $C3


#New Ceilick behavior, regular shoot
%patch $9047 $55 $8B $EC $56 $A1 $61 $53 $B1 $05 $D3 $E8 $25 $0001W  $05 $0002W
             $A1 $3A $99 $03 $06 $40 $5D $A3 $3A $99 $3D $0100W $7E $0C $C7 $06
             $3A $99 $0000W  $C7 $06 $42 $99 $9076W  $5E $5D $C3

#Shooting code, spawn Vizard's shots
%patch $9076 $55 $8B $EC $56 $B8 $0011W  $50 $E8 $38E8W  $59                #Shot sound
             $BE $0096W  $56 $A1 $991AW  $8B $16 $9918W  $81 $C2 $00
             $FF $15 $FFFFW  $50 $52 $FF $36 $9916W  $FF $36 $9914W  $E8    #Shot position, call shots
         $B49DW  $83 $C4 $0A $C7 $06 $9942W  $9047W  #Return to walking
             $5E $5D $C3

#Ceilick, Vizard stun Keen instead of push
%patch $7CBC $7C77W


#################################################
#Temporary Ceilick (For boss fight start	#
#################################################

#T.Ceilick initiation
%patch $0E5E $56 $57 $E8 $0823W  $59 $59 $E9 $2D52W

#T.Ceilick spawn (Minimal)
%patch $1686 $55 $8B $EC $56 $E8 $4930W  $8B $F0 $C7 $04 $0002W  $8B $46 $04 #Sprite type = 2
             $99 $B1 $0C $E8 $D525W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $D516W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $7E05W  #Behavior = vanish
             $C7 $44 $34 $6A00W  $C7 $44 $28 $0002W  $5E  $5D $C3


#################################################
#Win level sprite (For last level)		#
#################################################

#Winner initiation
%patch $0E68 $56 $57 $E8 $0856W  $59 $59 $E9 $2D48W

#Winner spawn
%patch $16C3 $55 $8B $EC $56 $E8 $48F3W  $8B $F0 $C7 $04 $0007W  $8B $46 $04 #Sprite type = 7
             $99 $B1 $0C $E8 $D4E8W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $D4D9W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $6A00W  #Behavior = sit
             $C7 $44 $34 $1700W  $C7 $44 $28 $0067W  $5E  $5D $C3

#Winner collision (If Keen touches, win level)
%patch $1700 $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $01 $75 $06 $C7
             $06 $6E8CW  $0001W  $5E $5D $C3


#################################################
#Squanon (For secret level)			#
#################################################

#Right Squanon initiation
%patch $176E $56 $57 $E8 $76E6W  $59 $59 $E9 $2442W

#Left Squanon initiation
%patch $1764 $56 $57 $E8 $76B4W  $59 $59 $E9 $244CW

#Messie doesn't move, can't pick up Keen (Frees $8E1D-92B1)
%patch $8CDE $EB $03

#Left Squanon spawn
%patch $8E1D $55 $8B $EC $56 $E8 $D199W  $8B $F0 $C7 $04 $0003W  $8B $46 $04 #Sprite type = 3
             $99 $B1 $0C $E8 $5D8EW  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $5D7FW  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $8F0EW  #Behavior = $8F0EW
             $C7 $44 $28 $0068W  $C7 $44 $34 $6A00W  $EB $3A                 #Use next Sq code

#Right Squanon spawn
%patch $8E59 $55 $8B $EC $56 $E8 $D15DW  $8B $F0 $C7 $04 $0003W  $8B $46 $04 #Sprite type = 3
             $99 $B1 $0C $E8 $5D52W  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $5D43W  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $8F97W  #Behavior = $8F97W
             $C7 $44 $34 $6A00W  $C7 $44 $28 $0054W  $5E  $5D $C3            #Collision: none


#Left Squanon make a shot (Type 3, stun under water)
%patch $8E96 $55 $8B $EC $56 $B8 $002BW  $50 $E8 $3AC8W
                 $59 $E8 $D118W  $8B $F0 $A1 $16 $99 $8B $16 $14 $99 $81 $C2
             $00 $FF $15 $FFFFW  $89 $54 $04 $89 $44 $06 $C7 $44 $20 $FE70W
             $B8 $0065W  $89 $44 $2A $89 $44 $28 $A1 $1A $99 $8B $16 $18 $99
             $81 $C2 $00 $16 $15 $0000W  $89 $54 $08 $89 $44 $0A $C7 $44 $32
             $5120W  $C7 $44 $34 $6A00W  $C7 $04 $0003W  $C7 $44 $22 $0000W
             $A1 $3E $99 $A3 $30 $99 $C7 $06 $42 $99 $8F0EW  $C7 $06 $3A $99
             $0000W  $5E $5D $C3

#Left Squanon pause behavior
%patch $8F0E $55 $8B $EC $A1 $3A $99 $03 $06 $40 $5D $A3 $3A $99 $3D $0130W
             $7E $06 $C7 $06 $42 $99 $8E96W  $5D $C3

#Right Squanon make a shott (Type 2, stun under water)
%patch $8F28 $55 $8B $EC $56 $B8 $002BW  $50 $E8 $3A36W
                 $59 $E8 $D086W  $8B $F0 $A1 $16 $99 $8B $16 $14 $99 $81 $C2
             $00 $1C $15 $0000W  $89 $54 $04 $89 $44 $06 $C7 $44 $20 $0190W
             $B8 $0065W  $89 $44 $2A $89 $44 $28 $A1 $1A $99 $8B $16 $18 $99
             $81 $C2 $00 $16 $15 $0000W  $89 $54 $08 $89 $44 $0A $C7 $44 $32
             $5120W  $C7 $44 $34 $6A00W  $C7 $04 $0003W  $C7 $44 $22 $0000W
             $A1 $3E $99 $A3 $30 $99 $C7 $06 $42 $99 $8F97W  $C7 $06 $3A $99
             $0000W  $5E $5D $C3

#Right Squanon pause behavior
%patch $8F97 $55 $8B $EC $A1 $3A $99 $03 $06 $40 $5D $A3 $3A $99 $3D $0130W
             $7E $06 $C7 $06 $42 $99 $8F28W  $5D $C3


#################################################
#Win bosslev (To stop cheating boss counter)	#
#################################################

#WBL initiation
%patch $1778 $56 $57 $E8 $7834W  $59 $59 $E9 $2438W

#WBL spawn (Harmless, sits, use exit tile anim)
%patch $8FB1 $55 $8B $EC $56 $E8 $D005W  $8B $F0 $C7 $04 $0007W  $8B $46 $04 #Sprite type = 7
             $99 $B1 $0C $E8 $5BFAW  $89 $44 $04 $89 $54 $06 $8B $46 $06 $99
             $B1 $0C $E8 $5BEBW  $89 $44 $08 $89 $54 $0A $C7 $44 $32 $6A00W  #Behavior = $6A00W
             $C7 $44 $34 $8FEEW  $C7 $44 $28 $0077W  $5E  $5D $C3            #Collision: none

#WBL collision (Win level, inc boss counter)
%patch $8FEE $55 $8B $EC $56 $8B $76 $04 $8B $5E $06 $83 $3F $01 $75 $0A $C7
             $06 $6E8CW  $0001W  $FF $06 $9D1AW  $5E $5D $C3


#################################################
#Sprite spawning central patch			#
#################################################

#Space -5E63 (Door open space)
#1st dual call to 62B4
#Free behavior space at
#Open ended behavior space at 4F26; 175A-1781


#List location
%patch $3ACA $0B5FW #Number

#Length
%patch $3AC7 $0030W
%patch $3ADE $60    #Number list length, bytes ($0BBF)

#Number list
%patch $0B5F $00FFW #Keen: 1
             $0001W #Vorticon Pirate
             $0002W #Spratlet
             $0003W #Vizard
             $0004W #Still birdform
             $0005W #Horizontal birdform
             $0006W #Vertical birdform
             $0007W #Boat
             $0008W #Crown
             $0009W #Gem
             $000AW #Chest
             $000BW #Hawk
             $000CW #Bat
             $000DW #Door
             $000EW #Yellow lock
             $000FW #Red lock
             $0010W #Green lock
             $0011W #Blue lock
             $0012W #SharKey
             $0013W #Bomblet
             $0014W #Left cannon
             $0015W #Right cannon
             $0016W #Left cannon firer
             $0017W #Right cannon firer
             $0018W #Snail
             $0019W #Lass
             $001AW #Spleen
             $001BW #Xky
             $001CW #Rush
             $001DW #Lick
             $001EW #Metroid
             $001FW #Rat
             $0020W #Octo
             $0021W #Lethality
             $0022W #TC
             $0023W #Winlev
             $0024W #Left Squanon
             $0025W #Right Squanon
             $0026W #Win boss level

#Pointer list
%patch $0BBF $3B94W #Keen
             $3ADFW #Vorticon
             $3AE9W #Spratlet
             $3AF3W #Vizard
             $3AFDW #Still bird
             $3B07W #H bird
             $3B11W #V bird
             $3B1BW #Boat
             $3B25W #Crown
             $3B39W #Gem
             $3B2FW #Chest
             $3B42W #Hawk
             $3B4BW #Bat
             $3B54W #Door
             $3B5DW #Yellow lock
             $3B66W #Red lock
             $3B6FW #Green lock
             $3B78W #Blue lock
             $3B81W #SharKey
             $3B8AW #TNT
             $3BD4W #Canon left
             $3BDDW #Canon right
             $3BE6W #Left firer
             $3BEFW #Right firer
             $3BF8W #Snail
             $3C01W #Lass
             $3C0AW #Spleen
             $3C13W #Xky
             $0E22W #Rush
             $0E36W #Lick
             $0E2CW #Metroid
             $0E40W #Rat
             $0E4AW #Octo
             $0E54W #Lethality
             $0E5EW #TC
             $0E68W #Winlev
             $176EW #Left Squanon
             $1764W #Right Squanon
             $1778W #Win boss level

%end
